#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/*
Simulates an all-to-one reduction to process target, as seen
from the point of view of process my_id.
*/
int all_to_one_reduction(int p, int my_id, int target) {

    int d, my_virtual_id, virtual_dest, mask, rshift, pow2i;

    rshift = p - target;

    d = ceil(log2(p));
    // We'll keep the convention that target obtains virtual_id = 0.
    my_virtual_id = ((my_id - rshift) + p) % p;

    pow2i = 1;
    mask = 0;

    printf("Process %d obtaining virtual_id %d\n", my_id, my_virtual_id);

    for (int i = 0; i < d; i ++) {

        if ((my_virtual_id & mask) == 0) {

            virtual_dest = my_virtual_id ^ pow2i;

            if ((my_virtual_id & pow2i) == 0) {

                if (virtual_dest < p) {
                    printf("Message received from %d\n", (virtual_dest + rshift) %p);
                } else {
                    printf("Doing nothing.\n");
                }

            } else {
                printf("Message sent to %d\n", (virtual_dest + rshift) % p);
            }
        } else {
            printf("Doing nothing.\n");
        }

        mask ^= pow2i;
        pow2i *= 2;
    }
}

int main(int narg, char **argv) {

    int p, my_id, target;

    if (narg >= 4) {
        p = atoi(argv[1]);
        my_id = atoi(argv[2]);
        target = atoi(argv[3]);

    } else {
        printf("usage %s p, target, my_id\n", argv[0]);
        return 0;
    }

    all_to_one_reduction(p, my_id, target);
}